# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from ... import _utilities, _tables
from ._inputs import *

__all__ = ['CatalogEventStorePredictionApiKeyRegistration']


class CatalogEventStorePredictionApiKeyRegistration(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 catalogs_id: Optional[pulumi.Input[str]] = None,
                 event_stores_id: Optional[pulumi.Input[str]] = None,
                 locations_id: Optional[pulumi.Input[str]] = None,
                 prediction_api_key_registration: Optional[pulumi.Input[pulumi.InputType['GoogleCloudRecommendationengineV1beta1PredictionApiKeyRegistrationArgs']]] = None,
                 prediction_api_key_registrations_id: Optional[pulumi.Input[str]] = None,
                 projects_id: Optional[pulumi.Input[str]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        Register an API key for use with predict method.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['GoogleCloudRecommendationengineV1beta1PredictionApiKeyRegistrationArgs']] prediction_api_key_registration: Required. The prediction API key registration.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if catalogs_id is None and not opts.urn:
                raise TypeError("Missing required property 'catalogs_id'")
            __props__['catalogs_id'] = catalogs_id
            if event_stores_id is None and not opts.urn:
                raise TypeError("Missing required property 'event_stores_id'")
            __props__['event_stores_id'] = event_stores_id
            if locations_id is None and not opts.urn:
                raise TypeError("Missing required property 'locations_id'")
            __props__['locations_id'] = locations_id
            __props__['prediction_api_key_registration'] = prediction_api_key_registration
            if prediction_api_key_registrations_id is None and not opts.urn:
                raise TypeError("Missing required property 'prediction_api_key_registrations_id'")
            __props__['prediction_api_key_registrations_id'] = prediction_api_key_registrations_id
            if projects_id is None and not opts.urn:
                raise TypeError("Missing required property 'projects_id'")
            __props__['projects_id'] = projects_id
        super(CatalogEventStorePredictionApiKeyRegistration, __self__).__init__(
            'gcp-native:recommendationengine/v1beta1:CatalogEventStorePredictionApiKeyRegistration',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'CatalogEventStorePredictionApiKeyRegistration':
        """
        Get an existing CatalogEventStorePredictionApiKeyRegistration resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        return CatalogEventStorePredictionApiKeyRegistration(resource_name, opts=opts, __props__=__props__)

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

